﻿// Copyright (c) Microsoft Corporation and Contributors.
// Licensed under the MIT License.

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Controls.Primitives;
using Microsoft.UI.Xaml.Data;
using Microsoft.UI.Xaml.Input;
using Microsoft.UI.Xaml.Media;
using Microsoft.UI.Xaml.Navigation;
using Microsoft.UI.Xaml.Shapes;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Threading.Tasks;
using Windows.ApplicationModel;
using Windows.ApplicationModel.Activation;
using Windows.Foundation;
using Windows.Foundation.Collections;
using MdlIsoReaderDotNetSDK;
using Shiny.BluetoothLE;
using Shiny;
using Microsoft.Extensions.DependencyInjection;
using System.Reactive.Linq;
using System.Reactive.Threading.Tasks;
using Windows.UI.Popups;
using Windows.UI.Core;
using Windows.System;
using WinRT.Interop;
using Windows.ApplicationModel.DataTransfer;
using ThinkSharp.Licensing;

// To learn more about WinUI, the WinUI project structure,
// and more about our project templates, see: http://aka.ms/winui-project-info.

namespace ExampleWinUI3ReaderApp
{
    /// <summary>
    /// Provides application-specific behavior to supplement the default Application class.
    /// </summary>
    public partial class App : Application
    {
        /// <summary>
        /// Initializes the singleton application object.  This is the first line of authored code
        /// executed, and as such is the logical equivalent of main() or WinMain().
        /// </summary>
        public App()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when the application is launched.
        /// </summary>
        /// <param name="args">Details about the launch request and process.</param>
        protected override void OnLaunched(Microsoft.UI.Xaml.LaunchActivatedEventArgs args)
        {
            m_window = new MainWindow();
            WindowHandle = WinRT.Interop.WindowNative.GetWindowHandle(m_window);

            // Create a Frame to act as the navigation context.
            Frame rootFrame = new Frame();
           // rootFrame.NavigationFailed += OnNavigationFailed;

            // Place the frame in the current Window
            m_window.Content = rootFrame;

            rootFrame.Navigate(typeof(MainPage), args.Arguments);

            m_window.Activate();
       
        }

        public static async Task MessageBox(string text, string title = null)
        {
            var messageDialog = new MessageDialog(text, title ?? string.Empty);
            InitializeWithWindow.Initialize(messageDialog, WindowHandle);
            var package = new DataPackage();
            package.SetText(HardwareIdentifier.ForCurrentComputer());
            Clipboard.SetContent(package);
            // Add commands and set their callbacks; both buttons use the same callback function instead of inline event handlers
            messageDialog.Commands.Add(new UICommand("Close"));
            // Set the command that will be invoked by default
            messageDialog.DefaultCommandIndex = 1;
            // Set the command to be invoked when escape is pressed
            messageDialog.CancelCommandIndex = 1;
            await messageDialog.ShowAsync();
        }

        public static IntPtr WindowHandle;

        private Window m_window;
    }
}
